#include <mpi.h>
#include <stdio.h>
#include <common/bgp_personality.h>
#include <common/bgp_personality_inlines.h>
#include <spi/kernel_interface.h> 

/* Returns two tasks from the same node
    First: verifies if vn or dual mode is running,
    Second: takes my node
    Third: picks two tasks
    Returns:
        0, if source and target are assigned
        1, if smp mode is running
*/    
int getranks( int *source, int *target )
{
  _BGP_Personality_t personality;
  _BGP_Personality_t *p = &personality;
  unsigned int x, y, z, t, size, rank;
  
  Kernel_GetPersonality(p, sizeof(personality));
  
  if ( personality.Kernel_Config.ProcessConfig == _BGP_PERS_PROCESSCONFIG_SMP )
      return 1;

  x = BGP_Personality_xCoord(p);
  y = BGP_Personality_yCoord(p);
  z = BGP_Personality_zCoord(p);
  
  //t = Kernel_PhysicalProcessorID();
  
  Kernel_Coord2Rank( x, y, z, 0, (unsigned *)source, &size );
  Kernel_Coord2Rank( x, y, z, 1, (unsigned *)target, &size );
  
  //printf("Node: <%u:%u:%u> %u -> %u \n", x, y, z, *source, *target );
  
  return 0; 
}
